<%@page import="javax.swing.ImageIcon"%>
<%@page import="java.io.OutputStream"%>
<%@page import="com.googlecode.jsonplugin.JSONUtil"%>
<%@page import="java.io.FileOutputStream"%>
<%@page import="org.apache.commons.io.IOUtils"%>
<%@page import="java.io.File"%>
<%@page import="java.text.SimpleDateFormat"%>
<%@page import="org.apache.commons.io.FilenameUtils"%>
<%@page import="org.apache.commons.io.FileUtils"%>
<%@page import="java.io.InputStream"%>
<%@page import="org.apache.commons.fileupload.FileItemStream"%>
<%@page import="org.apache.commons.fileupload.FileItemIterator"%>
<%@page import="org.apache.commons.fileupload.servlet.ServletFileUpload"%>
<%@page import="org.apache.commons.fileupload.FileUpload"%>
<%@ page language="java" import="java.util.*" pageEncoding="UTF-8"%>
<%
	String save_dir = "upload/", save_url = "upload/", file_field_name = "file", exts = "";
	int max_size = 1024 * 1204;
	out.print(JSONUtil.serialize(uploadImage(request, save_dir,
			save_url, file_field_name, max_size, exts, true)));
		 
%>
<%!/**
	 * 处理上传文件
	 * 返值结构
	 * -error  出错代码,0表示成功
	 * -message   出错信息
	 * -url         保存后的网址
	 * -file        相对保存目录的文件路径
	 * -name        原始文件名
	 * -ext         上传文件的后缀小写形式,如".jpg"
	 * @param string save_dir    保存文件目录
	 * @param stringsave_url    目录的web访问网址
	 * @param string  file_field_name  表单名
	 * @param int max_size    文件最大尺寸
	 * @param bool auto_create_sub_dir 是否将自动建子目录来保存文件
	 * @param string exts  允许后缀,多个后缀用分号";"隔开,"*"表示所有. 图片后缀例: "jpg;gif;png"
	 * @return array
	 */
	public Map<String, Object> uploadFile(HttpServletRequest request,
			String save_dir, String save_url, String file_field_name,
			Integer max_size, String exts, Boolean auto_create_sub_dir) {
		file_field_name = null == file_field_name ? "file" : file_field_name;
		max_size = null == max_size ? 0 : max_size;
		exts = null == exts || "".equals(exts) ? "*" : exts;
		String[] extsa = exts.split(";");
		auto_create_sub_dir = null == auto_create_sub_dir ? false
				: auto_create_sub_dir;
		Map<String, Object> result = new HashMap<String, Object>();
		result.put("error", 0);

		if (!ServletFileUpload.isMultipartContent(request)) {
			result.put("error", 1);
			result.put("message", "失败:上传失败!请设置 enctype='multipart/form-date'");
			return result;
		}
		ServletFileUpload uploadFile = new ServletFileUpload();
		try {
			FileItemIterator uploads = uploadFile.getItemIterator(request);
			if (uploads.hasNext()) {
				FileItemStream upload = uploads.next();
				InputStream uploadIn = upload.openStream();
				if (max_size > 0 && uploadIn.available() > max_size) {
					result.put("error", 2);
					String size = "";
					if (max_size > 1048576) {
						size = max_size / 1048576 + "MB";
					} else if (max_size > 1024) {
						size = max_size / 1024 + "KB";
					} else {
						size = max_size + "B";
					}
					result.put("message", "失败:文件太大, 请上传小于 " + size + " 的文件");
					return result;
				}
				result.put("name", upload.getFieldName());
				String fileName = upload.getName();
				String ext = FilenameUtils.getExtension(fileName);
				List<String> ex = Arrays.asList(extsa);
				if (!ex.contains(ext) && ex.contains("*") && ex.contains("*.*")) {
					result.put("error", 3);
					result.put("message", "失败:请上传(" + ext + " 格式文件");
					return result;
				}
				SimpleDateFormat smf = new SimpleDateFormat("yyyyMM/dd/");
				String p = auto_create_sub_dir ? smf.format(new Date()) : "";
				File saveDirFile = new File(save_dir + p);
				if (!saveDirFile.exists() && !saveDirFile.mkdirs()) {
					result.put("error", "4");
					result.put("message", "失败:建目录[" + save_dir + p + "]失败");
				}
			    System.out.println(saveDirFile.getAbsolutePath());
				String fName = System.currentTimeMillis() + "." + ext;
				p = p + fName;
				String save_file = save_dir + p;
				try {
					OutputStream out = new FileOutputStream(save_file);
					IOUtils.copyLarge(uploadIn, out);
					out.flush();
					out.close();
				} catch (Exception e) {
					result.put("error", 5);
					result.put("message", "失败, 写入文件" + save_file + "失败");
					return result;
				}
				result.put("url", save_url + p);
				result.put("file", save_file);
			}
		} catch (Exception e) {
			e.printStackTrace();
			result.put("error", 1);
			result.put("message", "失败:上传失败");
			return result;
		}
		return result;
	}

	public Map<String, Object> uploadImage(HttpServletRequest request,
			String save_dir, String save_url, String file_field_name,
			Integer max_size, String exts, Boolean auto_create_sub_dir) {
		file_field_name = null==file_field_name || "".equals(file_field_name)?"file":file_field_name;
		max_size = null==max_size?2097152:max_size;
		exts = null==exts||"".equals(exts)?"jpg;gif;png":exts;
		auto_create_sub_dir =null==auto_create_sub_dir? true:auto_create_sub_dir;
		Map<String, Object> result = uploadFile(request, save_dir, save_url,
				file_field_name, max_size, exts, auto_create_sub_dir);
		result.put("width", 0);
		result.put("height", 0);
		Integer error = (Integer) result.get("error");
		if (null != error && error == 0) {
			ImageIcon icon = new ImageIcon((String) result.get("file"));
			result.put("width", icon.getIconWidth());
			result.put("height", icon.getIconHeight());
		}
		return result;
	}%>